"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _pluginProposalOptionalChaining = _interopRequireDefault(require("@babel/plugin-proposal-optional-chaining"));
var _pluginProposalPipelineOperator = _interopRequireDefault(require("@babel/plugin-proposal-pipeline-operator"));
var _presetEnv = _interopRequireDefault(require("@babel/preset-env"));
var _presetTypescript = _interopRequireDefault(require("@babel/preset-typescript"));
var _babelPresetJsx = _interopRequireDefault(require("@vue/babel-preset-jsx"));
var _babelPluginAddModuleExports = _interopRequireDefault(require("babel-plugin-add-module-exports"));
var _babelPluginMacros = _interopRequireDefault(require("babel-plugin-macros"));
var _babelPluginModuleResolver = _interopRequireWildcard(require("babel-plugin-module-resolver"));
var _babelPluginTransformImports = _interopRequireDefault(require("babel-plugin-transform-imports"));
var _babelPluginWildcard = _interopRequireDefault(require("babel-plugin-wildcard"));
var _depcheckPackageName = _interopRequireDefault(require("depcheck-package-name"));
var _findUp = _interopRequireDefault(require("find-up"));
var _loadPkg = _interopRequireDefault(require("load-pkg"));
var _paramCase = require("param-case");
var _path = _interopRequireDefault(require("path"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var _default = () => {
  const packageConfig = _loadPkg.default.sync() || {};
  return {
    plugins: [_pluginProposalOptionalChaining.default, [_pluginProposalPipelineOperator.default, {
      proposal: 'fsharp'
    }], ...(packageConfig.type === 'module' ? [] : [_babelPluginAddModuleExports.default]), [_babelPluginModuleResolver.default, {
      alias: {
        '@': '.'
      },
      resolvePath: (sourcePath, currentFile, options) => {
        const rootPath = _findUp.default.sync(['package.json', '.root'], {
          cwd: _path.default.dirname(currentFile)
        });
        const rootDir = rootPath ? _path.default.dirname(rootPath) : undefined;
        return (0, _babelPluginModuleResolver.resolvePath)(sourcePath, currentFile, {
          ...options,
          cwd: rootDir
        });
      }
    }], [_babelPluginTransformImports.default, {
      [(0, _depcheckPackageName.default)`@dword-design/functions`]: {
        transform: importName => {
          var _importName;
          return `@dword-design/functions/dist/${(_importName = importName, (0, _paramCase.paramCase)(_importName))}.js`;
        }
      }
    }], [_babelPluginWildcard.default, {
      exts: []
    }], _babelPluginMacros.default],
    presets: [[_presetEnv.default, packageConfig.type === 'module' ? {
      modules: false,
      targets: {
        node: 14
      }
    } : {
      targets: {
        node: 10
      }
    }], _babelPresetJsx.default, _presetTypescript.default]
  };
};
exports.default = _default;
module.exports = exports.default;